// accordi.cpp : Defines the entry point for the application.
//

#include <Windows.h>
#include "resource.h"
#include "string.h"
#include "tab.h"
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	About(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	About1(HWND, UINT, WPARAM, LPARAM);

DWORD MidiOutMessage(HMIDIOUT,int,int,int,int);
DWORD MidiNoteOn(HMIDIOUT,int,int,int);
DWORD MidiNoteOff(HMIDIOUT,int,int,int);

void Inizializza(HWND);
void TrovaAccordo(HDC);
void Capotasto(HDC); 
HFONT MyCreateFont(void);
HWND hWnd;
HINSTANCE hInst;// current instance
int m; // memorizza se acordo maggiore o minore
char accordo[12];// Contiene prima l'accordo scelto e poi la sua intavolatura
char num[7]; //contiene le variazioni di accordi 4/5/7/....
 
int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
 
	MSG msg;

	MyRegisterClass(hInstance);

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow)) 
	{
		return FALSE;
	}


	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		
	}

	return msg.wParam;
}



//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage is only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (DLGPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= DLGWINDOWEXTRA;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, (LPCTSTR)IDI_ACCORDI);
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)COLOR_WINDOW;
	wcex.lpszMenuName	= "Id_Accordi";
	wcex.lpszClassName	= "Accordi";
	wcex.hIconSm		= LoadIcon(wcex.hInstance, (LPCTSTR)IDI_ACCORDI);

	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HANDLE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
  

   hInst = hInstance; // Store instance handle in our global variable

  
  hWnd=CreateDialog(hInstance,(LPCTSTR)ACCORDI,0,NULL);
   if (!hWnd)
   {
      return FALSE;
   }
   Inizializza(hWnd);
    
    midiOutOpen(&hMidiOut,iDevice,0,0,0);
				 
   ShowWindow(hWnd, nCmdShow);
   
   UpdateWindow(hWnd);

   return TRUE;
}





LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	HWND hLst;
	HDC hdc;
	RECT rect;
	 HFONT hfnt,hOldFont;
	switch (message) 
	{
		
	case WM_INITDIALOG:
	      
		return TRUE;
			break; 
	 case WM_COMMAND:
			wmId    = LOWORD(wParam); 
			wmEvent = HIWORD(wParam); 
			// Parse the menu selections:
			if(wmEvent==CBN_EDITCHANGE     )
			{SendDlgItemMessage(hWnd,IDOK,WM_LBUTTONDOWN,0,0);
             SendDlgItemMessage(hWnd,IDOK,WM_LBUTTONUP,0,0);
			}
			switch (wmId)
			{
	        
			case IDC_BUTTON1:
				for (y=0;y<=5;y++){
				if(acc[y*2]!=15)
					MidiNoteOn(hMidiOut,iChannel,note[y]+acc[y*2],iVelocity);
				Sleep(100);
				}
				MidiNoteOff(hMidiOut,iChannel,note[y]+acc[y],0);
				break;
		
			case IDC_CHECK1:	
			   case IDOK:
				    GetDlgItemText(hWnd,IDC_COMBO1,accordo,5);
                    GetDlgItemText(hWnd,IDC_COMBO4,num,7);
				    if(SendDlgItemMessage(hWnd,IDC_CHECK1,BM_GETCHECK,0,0))
					 m=1;else m=0;
   
					  hLst=GetDlgItem(hWnd,IDC_EDIT1);
					  hdc=GetDC(hLst);

					   GetClientRect(hLst,&rect);
					   PatBlt(hdc,rect.left,rect.top,rect.right,rect.bottom,BLACKNESS);
     				     hfnt=MyCreateFont();
                         hOldFont=SelectObject(hdc,hfnt);
					   SetBkMode(hdc,TRANSPARENT);
         
		          SelectObject (hdc, GetStockObject (NULL_BRUSH)) ; 
						 Capotasto(hdc);
					   TrovaAccordo(hdc);
                       ReleaseDC(hLst,hdc);
				  EnableWindow(GetWindow(hWnd,IDC_BUTTON1),TRUE);    
				   break;
				
				       
				case IDC_ESCI:
				    midiOutClose(hMidiOut);
					PostQuitMessage(0);
				   break;
				default:
				   return DefWindowProc(hWnd, message, wParam, lParam);
			}
			break;
		
			
		case WM_DESTROY:
			PostQuitMessage(0);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
   }
   return 0;
}

// Mesage handler for about box.


void Capotasto(HDC hdc)
{
int x;

SelectObject(hdc,CreatePen(PS_SOLID,0,RGB(230,230,230)));
SelectObject(hdc,CreateSolidBrush(RGB(164,115,0)));
                       //linee corde 
                       MoveToEx(hdc,20,60,NULL);
				       LineTo(hdc,580,60);
					   
					   MoveToEx(hdc,20,80,NULL);
					   LineTo(hdc,580,80);
					   
					   MoveToEx(hdc,20,100,NULL);
					   LineTo(hdc,580,100);
					   
					   MoveToEx(hdc,20,120,NULL);
					   LineTo(hdc,580,120);
					   MoveToEx(hdc,20,119,NULL);
					   LineTo(hdc,580,119);

					   MoveToEx(hdc,20,140,NULL);
					   LineTo(hdc,580,140);
					   MoveToEx(hdc,20,139,NULL);
					   LineTo(hdc,580,139);

					   MoveToEx(hdc,20,159,NULL);
					   LineTo(hdc,580,159);
					   MoveToEx(hdc,20,160,NULL);
					   LineTo(hdc,580,160);
                       
					   //linee capotasto 
					   MoveToEx(hdc,18,59,NULL);
					   LineTo(hdc,18,162);
					   MoveToEx(hdc,19,59,NULL);
					   LineTo(hdc,19,162);
                       MoveToEx(hdc,20,59,NULL);
					   LineTo(hdc,20,162);
	   
				       //linee capotasti
					   MoveToEx(hdc,60,59,NULL);
					   LineTo(hdc,60,162);

					   MoveToEx(hdc,100,59,NULL);
					   LineTo(hdc,100,162);
					   
					   MoveToEx(hdc,140,59,NULL);
					   LineTo(hdc,140,162);

					   MoveToEx(hdc,180,59,NULL);
					   LineTo(hdc,180,162);
					   
					   MoveToEx(hdc,220,59,NULL);
					   LineTo(hdc,220,162);

					   MoveToEx(hdc,260,59,NULL);
					   LineTo(hdc,260,162);

					   MoveToEx(hdc,300,59,NULL);
					   LineTo(hdc,300,162);

					   MoveToEx(hdc,340,59,NULL);
					   LineTo(hdc,340,162);
					   
					   MoveToEx(hdc,380,59,NULL);
					   LineTo(hdc,380,162);

					    MoveToEx(hdc,420,59,NULL);
					   LineTo(hdc,420,162);

					    MoveToEx(hdc,460,59,NULL);
					   LineTo(hdc,460,162);
					   
					    MoveToEx(hdc,500,59,NULL);
					   LineTo(hdc,500,162);
					   
					    MoveToEx(hdc,540,59,NULL);
					   LineTo(hdc,540,162);
					    MoveToEx(hdc,580,59,NULL);
					   LineTo(hdc,580,162);
for(x=0;x<540;x+=40)
FloodFill(hdc,22+x,62,RGB(230,230,230));					    
					   
for(x=0;x<540;x+=40)
FloodFill(hdc,22+x,82,RGB(230,230,230));					    

for(x=0;x<540;x+=40)
FloodFill(hdc,22+x,102,RGB(230,230,230));					    

for(x=0;x<540;x+=40)
FloodFill(hdc,22+x,122,RGB(230,230,230));					    

for(x=0;x<540;x+=40)
FloodFill(hdc,22+x,142,RGB(230,230,230));					    

SelectObject(hdc,CreatePen(PS_SOLID,0,RGB(230,230,230)));
for(x=0;x<6;x++){
Ellipse(hdc,115+x,105+x,125-x,115-x);

Ellipse(hdc,195+x,105+x,205-x,115-x);

Ellipse(hdc,275+x,85+x,285-x,95-x);

Ellipse(hdc,275+x,125+x,285-x,135-x);

Ellipse(hdc,355+x,105+x,365-x,115-x);

Ellipse(hdc,475+x,85+x,485-x,95-x);
Ellipse(hdc,475+x,125+x,485-x,135-x);
}

}

void TrovaAccordo(HDC hdc)
{
int x;
char dito[3];


			  if(strcmp(accordo,"DO")==0)x=0;
			  if(strcmp(accordo,"DO#")==0)x=1;
			  if(strcmp(accordo,"REb")==0)x=1;
			  if(strcmp(accordo,"RE")==0)x=2;
			  if(strcmp(accordo,"RE#")==0)x=3;
			  if(strcmp(accordo,"MIb")==0)x=3;
			  if(strcmp(accordo,"MI")==0)x=4;
			  if(strcmp(accordo,"FA")==0)x=5;
			  if(strcmp(accordo,"FA#")==0)x=6;
			  if(strcmp(accordo,"SOLb")==0)x=6;
			  if(strcmp(accordo,"SOL")==0)x=7;
			  if(strcmp(accordo,"SOL#")==0)x=8;
			  if(strcmp(accordo,"LAb")==0)x=8;
			  if(strcmp(accordo,"LA")==0)x=9;
			  if(strcmp(accordo,"LA#")==0)x=10;
			  if(strcmp(accordo,"SIb")==0)x=10;
			  if(strcmp(accordo,"SI")==0)x=11;
			  
   if(strcmp(num,"7")==0)
	   if(m){for (y=0;y<=11;y++)acc[y]=accm7[x][y];strcat(accordo," m 7");}
	      else {for (y=0;y<=11;y++)acc[y]=accM7[x][y];strcat(accordo," M 7");}
    else
    if(strcmp(num,"7+")==0)
	   if(m){for (y=0;y<=11;y++)acc[y]=accm7p[x][y];strcat(accordo," m 7+");}
	      else{ for (y=0;y<=11;y++)acc[y]=accM7p[x][y];strcat(accordo," M 7+");}
    else
   if(strcmp(num,"6")==0)
	 if(m){for (y=0;y<=11;y++)acc[y]=accm6[x][y];strcat(accordo," m 6");}
	 else {for (y=0;y<=11;y++)acc[y]=accM6[x][y];strcat(accordo," M 6");}
    
	 else
		if(strcmp(num,"5")==0){for (y=0;y<=11;y++)acc[y]=acc5[x][y];strcat(accordo," 5");}
      else

		  if(strcmp(num,"4")==0)
if(m){for (y=0;y<=11;y++)acc[y]=accm4[x][y];strcat(accordo," m 4");}
else {for (y=0;y<=11;y++)acc[y]=accM4[x][y];strcat(accordo," M 4");}

   else
if(strcmp(num,"9")==0)
	   {for (y=0;y<=11;y++)acc[y]=acc9[x][y];strcat(accordo," 9");}

  else
if(strcmp(num,"dim")==0)
{for (y=0;y<=11;y++)acc[y]=accdim[x][y];strcat(accordo," dim");}
	      
else
if(strcmp(num,"5+")==0)
if(m){for (y=0;y<=11;y++)acc[y]=accm5p[x][y];strcat(accordo," m 5+");}
else {for (y=0;y<=11;y++)acc[y]=accM5p[x][y];strcat(accordo," M 5+");}

else
if(strcmp(num,"7/4")==0)
if(m){for (y=0;y<=11;y++)acc[y]=accm74[x][y];strcat(accordo," m 7/4");}
else {for (y=0;y<=11;y++)acc[y]=accM74[x][y];strcat(accordo," M 7/4");}

else
if(strcmp(num,"7/5-")==0)
if(m){for (y=0;y<=11;y++)acc[y]=accm75m[x][y];strcat(accordo," m 7/5-");}
else {for (y=0;y<=11;y++)acc[y]=accM75m[x][y];strcat(accordo," M 7/5-");}

else
if(strcmp(num,"7+/5+")==0)
{for (y=0;y<=11;y++)acc[y]=acc7p5p[x][y];strcat(accordo," 7+/5+");}

else
if(strcmp(num,"7+/5-")==0)
{for (y=0;y<=11;y++)acc[y]=acc7p5m[x][y];strcat(accordo," 7+/5-");}

else
if(strcmp(num,"sus4")==0)
{for (y=0;y<=11;y++)acc[y]=accsus4[x][y];strcat(accordo," sus 4");}

else

if(strcmp(num,"5-")==0)

{for (y=0;y<=11;y++)acc[y]=accM5m[x][y];strcat(accordo," M5-");}

else

if(m){for (y=0;y<=11;y++)acc[y]=accm[x][y];strcat(accordo," m");}
else {for (y=0;y<=11;y++)acc[y]=accM[x][y];strcat(accordo," M");}


//stampa dell'accordo 
		  for (y=0;y<=10;y+=2){
			  SetTextColor(hdc,RGB(255,0,0));
			  if(acc[y+1]==15)
			TextOut (hdc,1,149-y*10,"x",1);
		else
           if(acc[y+1]==0)TextOut (hdc, 1,149-y*10,"o",1);
	         else
				 
			{
             SetTextColor(hdc,RGB(255,255,90));
			itoa(acc[y+1],dito,10);
		    TextOut (hdc, 34+(acc[y]-1)*40,150-y*10,dito,1);
			}
    SetTextColor(hdc,RGB(0,0,255));
	TextOut (hdc,260,25,accordo,strlen(accordo));
}




  }

  void Inizializza( HWND hWnd)
  {
            SendDlgItemMessage(hWnd,IDC_COMBO1,CB_ADDSTRING,0,(LPARAM) (LPCTSTR) "DO");
			SendDlgItemMessage(hWnd,IDC_COMBO1,CB_ADDSTRING,0,(LPARAM) (LPCTSTR) "RE");
			SendDlgItemMessage(hWnd,IDC_COMBO1,CB_ADDSTRING,0,(LPARAM) (LPCTSTR) "MI");
			SendDlgItemMessage(hWnd,IDC_COMBO1,CB_ADDSTRING,0,(LPARAM) (LPCTSTR) "FA");
			SendDlgItemMessage(hWnd,IDC_COMBO1,CB_ADDSTRING,0,(LPARAM) (LPCTSTR) "SOL");
			SendDlgItemMessage(hWnd,IDC_COMBO1,CB_ADDSTRING,0,(LPARAM) (LPCTSTR) "LA");
			SendDlgItemMessage(hWnd,IDC_COMBO1,CB_ADDSTRING,0,(LPARAM) (LPCTSTR) "SI");
			SendDlgItemMessage(hWnd,IDC_COMBO1,CB_ADDSTRING,0,(LPARAM) (LPCTSTR) "DO#");
			SendDlgItemMessage(hWnd,IDC_COMBO1,CB_ADDSTRING,0,(LPARAM) (LPCTSTR) "RE#");
			SendDlgItemMessage(hWnd,IDC_COMBO1,CB_ADDSTRING,0,(LPARAM) (LPCTSTR) "FA#");
			SendDlgItemMessage(hWnd,IDC_COMBO1,CB_ADDSTRING,0,(LPARAM) (LPCTSTR) "SOL#");
			SendDlgItemMessage(hWnd,IDC_COMBO1,CB_ADDSTRING,0,(LPARAM) (LPCTSTR) "LA#");
			SendDlgItemMessage(hWnd,IDC_COMBO1,CB_ADDSTRING,0,(LPARAM) (LPCTSTR) "REb");
			SendDlgItemMessage(hWnd,IDC_COMBO1,CB_ADDSTRING,0,(LPARAM) (LPCTSTR) "MIb");
			SendDlgItemMessage(hWnd,IDC_COMBO1,CB_ADDSTRING,0,(LPARAM) (LPCTSTR) "SOLb");
			SendDlgItemMessage(hWnd,IDC_COMBO1,CB_ADDSTRING,0,(LPARAM) (LPCTSTR) "LAb");
			SendDlgItemMessage(hWnd,IDC_COMBO1,CB_ADDSTRING,0,(LPARAM) (LPCTSTR) "SIb");
			
			SendDlgItemMessage(hWnd,IDC_COMBO1,CB_SETCURSEL,(WPARAM) 0,0);
			SendDlgItemMessage(hWnd,IDC_COMBO4,CB_ADDSTRING,0,(LPARAM) (LPCTSTR) " ");
			SendDlgItemMessage(hWnd,IDC_COMBO4,CB_ADDSTRING,0,(LPARAM) (LPCTSTR) "dim");
			SendDlgItemMessage(hWnd,IDC_COMBO4,CB_ADDSTRING,0,(LPARAM) (LPCTSTR) "4");
			SendDlgItemMessage(hWnd,IDC_COMBO4,CB_ADDSTRING,0,(LPARAM) (LPCTSTR) "5");
			SendDlgItemMessage(hWnd,IDC_COMBO4,CB_ADDSTRING,0,(LPARAM) (LPCTSTR) "5+");
			SendDlgItemMessage(hWnd,IDC_COMBO4,CB_ADDSTRING,0,(LPARAM) (LPCTSTR) "5-");
			SendDlgItemMessage(hWnd,IDC_COMBO4,CB_ADDSTRING,0,(LPARAM) (LPCTSTR) "6");
			SendDlgItemMessage(hWnd,IDC_COMBO4,CB_ADDSTRING,0,(LPARAM) (LPCTSTR) "7");
			SendDlgItemMessage(hWnd,IDC_COMBO4,CB_ADDSTRING,0,(LPARAM) (LPCTSTR) "7+");
			SendDlgItemMessage(hWnd,IDC_COMBO4,CB_ADDSTRING,0,(LPARAM) (LPCTSTR) "7/4");
			SendDlgItemMessage(hWnd,IDC_COMBO4,CB_ADDSTRING,0,(LPARAM) (LPCTSTR) "7/5-");

			SendDlgItemMessage(hWnd,IDC_COMBO4,CB_ADDSTRING,0,(LPARAM) (LPCTSTR) "7+/5-");
            SendDlgItemMessage(hWnd,IDC_COMBO4,CB_ADDSTRING,0,(LPARAM) (LPCTSTR) "7+/5+");
            SendDlgItemMessage(hWnd,IDC_COMBO4,CB_ADDSTRING,0,(LPARAM) (LPCTSTR) "9");
			
			SendDlgItemMessage(hWnd,IDC_COMBO4,CB_ADDSTRING,0,(LPARAM) (LPCTSTR) "sus4");
		     
  }

HFONT  MyCreateFont(void)
  {
	 // CHOOSEFONT cf;
	  //LOGFONT lf;
        HFONT hfont;
	
	  LOGFONT lf;
		//inizializza i mebri della struttura CHOOSEFONT
/*
	  cf.lStructSize = sizeof(CHOOSEFONT);
	  cf.hwndOwner = (HWND) NULL;
	  cf.hDC= (HDC)NULL;
	  cf.lpLogFont = &lf;
	  cf.iPointSize = 0;
	  cf.Flags = CF_SCREENFONTS;
	  cf.rgbColors = RGB(0,0,0);
	  cf.lCustData = 0L;
	  cf.lpfnHook = (LPCFHOOKPROC)NULL;
	  cf.lpTemplateName = (LPSTR)NULL;
	  cf.hInstance = (HINSTANCE)NULL;
	  cf.lpszStyle = (LPSTR)NULL;
	  cf.nFontType = SCREEN_FONTTYPE;
	  cf.nSizeMin = 0;
	  cf.nSizeMax = 0;

	  //visualizza il common-dialogbox CHOOSEFONT
	  ChooseFont(&cf);
*/	  

	  lf.lfCharSet= -19;
	  lf.lfClipPrecision= 0;
	  lf.lfEscapement = 0;
	  lf.lfFaceName ;
	  lf.lfHeight =22;
	  lf.lfItalic = 0;
	  lf.lfOrientation = 0;
	  lf.lfOutPrecision = 0;
	  lf.lfPitchAndFamily = 0;
	  lf.lfQuality = 0;
	  lf.lfStrikeOut = 0;
	  lf.lfUnderline = 0;
	  lf.lfWeight =400;
	  lf.lfWidth = 0;
	  	  

	  hfont=CreateFontIndirect(&lf);
	  return (hfont);
  }

DWORD MidiOutMessage(HMIDIOUT hMidi,int iStatus,int iChannel,int iData1,int iData2)
{
	DWORD dwMessage;
	dwMessage=iStatus|iChannel|(iData1<<8)|(iData2<<16);
	return midiOutShortMsg(hMidi,dwMessage);
}


DWORD MidiNoteOn(HMIDIOUT hMidi,int iChannel,  int iNote, int iVel)
{
	return MidiOutMessage(hMidi,0x090,iChannel,iNote,iVel);

}


DWORD MidiNoteOff(HMIDIOUT hMidi,int iChannel,  int iNote, int iVel)
{
	return MidiOutMessage(hMidi,0x080,iChannel,iNote,iVel);
}

